<?php
declare(strict_types=1);

namespace Inti\Wp\Provider;

use Inti\Wp\Plugin\Service\PluginManager;
use Laminas\ServiceManager\Factory\InvokableFactory;

/**
 * Class ConfigProvider
 *
 * @package Inti\Wp\Provider
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-provider
 */
final class ConfigProvider
{
    public function __invoke(): array
    {
        return [
            'wp' => [
                'plugins' => [

                ],
            ],

            PluginManager::class => [
                'factories' => [
                    Plugin\ProvideMetadata::class => Plugin\Factory\ProviderPluginFactory::class,
                    Plugin\ProvidePosts::class => Plugin\Factory\ProviderPluginFactory::class,
                    Plugin\RegisterTypes::class => Plugin\Factory\ProviderPluginFactory::class,
                ],
            ],

            'dependencies' => [
                'factories' => [
                    Service\IdOffsets::class => InvokableFactory::class,
                    Service\ProviderCollection::class => Container\ProviderCollectionFactory::class,
                    Service\ProviderManager::class => Container\ProviderManagerFactory::class,
                ],
            ],
        ];
    }
}
