<?php
declare(strict_types=1);

namespace Inti\Wp\Provider;

/**
 * Interface ObjectProviderInterface
 *
 * @package Inti\Wp\Provider
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-provider
 */
interface ObjectProviderInterface
{
    public function count(array $criteria = []): int;
    public function findByIds(array $ids): array;
    public function findBySlug(string $slug): ?array;
    public function getAll(int $limit, int $offset = 0): array;
    public function search(string $query, int $limit, int $offset = 0): array;
}
