<?php
declare(strict_types=1);

namespace Inti\Wp\Provider\Plugin\Factory;

use Inti\Wp\Plugin\PluginInterface;
use Inti\Wp\Provider\Service\IdOffsets;
use Inti\Wp\Provider\Service\ProviderCollection;
use Psr\Container\ContainerInterface;

/**
 * Class ProviderPluginFactory
 *
 * @package Inti\Wp\Provider\Plugin\Factory
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-provider
 */
final class ProviderPluginFactory
{
    public function __invoke(ContainerInterface $container, string $requestedName): PluginInterface
    {
        $providers = $container->get(ProviderCollection::class);
        $idOffsets = $container->get(IdOffsets::class);

        return new $requestedName($providers, $idOffsets);
    }
}
