<?php
declare(strict_types=1);

namespace Inti\Wp\Provider\Type;

/**
 * Opisuje vrstu WP objekta.
 *
 * @package Inti\Wp\Provider\Type
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp-provider
 */
interface ObjectTypeInterface
{
    public function getCapabilities(): array;
    public function getDescription(): string;
    public function getKey(): string;
    public function getLabels(): array;
    public function getMetaBoxCallback(): ?callable;
    public function getObjectType(): string;
    /** @return string|bool */
    public function getQueryVar();
    /**
     * @return string|bool
     */
//    public function getRestBase();

    /**
     * @return string|bool
     */
//    public function getRestControllerClass();

    /** @return bool|array */
    public function getRewriteConfig();
    public function isBuiltin(): bool;
    public function isHierarchical(): bool;
    public function isPublic(): bool;
    public function isPubliclyQueryable(): ?bool;
    /** @return string|bool|null */
    public function showInMenu();
    public function showInNavMenus(): ?bool;
//    public function showInRest(): bool;
    public function showUi(): ?bool;
}
